import numpy as np
import urllib2
import pandas
from pandas import DataFrame as df
from Bio.Blast import NCBIWWW
from Bio import Entrez, SeqIO
email = "drapja@live.unc.edu"#in order to sign into Entrez. Please change this if you are not James Draper.
Entrez.email = email

class Drapgen:
    def __init__(self,obj):
        if type(obj) != list:
            obj = [obj]
        items = ["Name","Nucgi","Protgi","Nucname","Nucseq","AAseq"]
        self.za = df(np.zeros((len(obj),len(items))),index = obj, columns = items)
        
        for i in obj:
            #SEARCH FOR CODING STRAND
            item = i
            species = 'Arabidopsis thaliana'
            search_string = item + "[Gene] "+species+"[Organism]"+" AND mRNA[Filter] AND RefSeq[keyword]"
            #GET DNA GI
            try:
                handle = Entrez.esearch(db="nucleotide", term=search_string)
                record = Entrez.read(handle)
                f = record["IdList"][0]
                self.za.loc[i,('Nucgi')] = f
            except IndexError:
                f = np.NAN
                self.za.loc[i,'Nucgi'] = f
        #GET cDNA SEQUENCE
            try:
                handle = Entrez.efetch(db="Nucleotide", id= f, rettype = "gb")
                n = SeqIO.read(handle, "gb")
                #Assigns the Nucleotide sequence
                self.za.loc[i,'Nucseq']= str(n.seq)
                self.za.loc[i,'Nucname'] = str(n.name)
            except AttributeError:
                self.za.loc[i,'Nucseq'] = np.NAN

            search_string = item + "[Gene] "+species+"[Organism]"
            #GET PROTEIN GI
            try:
                handle = Entrez.esearch(db="protein", term=search_string)
                record = Entrez.read(handle)
                t = record["IdList"][0]
                self.za.loc[i,'Protgi'] = t
                #GET AMINO ACID SEQUENCE
                try:
                    handle = Entrez.efetch(db="Protein", id= t, rettype = "gb")
                    r = SeqIO.read(handle, "gb")
                    self.za.loc[i,'AAseq'] =  str(r.seq)
                    self.za.loc[i,'Name']= str(r.name)
                except AttributeError:
                    self.AAseq = np.NAN
            except:
                self.protgi = np.NAN      